@REM
@REM build
@REM

@REM
@REM RpC
@REM

@REM RpCOo͐
@SET COMPILE_LOG_FILE=.\compile.log
@SET COMPILE2_LOG_FILE=.\compile2.log

@REM ʏRpC
@SETLOCAL
@CALL "%CALL_VCVARSALL_CMD%" %VCVARSALL_ARG% >NUL
@SET COMPILE_EXECUTE_CMD=cl ".\prime.factor.cpp" %CL_ARG% /EHsc /W4 /Feprime.factor.exe
@ECHO %COMPILE_EXECUTE_CMD%
@%COMPILE_EXECUTE_CMD%>>"%COMPILE_LOG_FILE%" 2>&1
@ENDLOCAL

@REM ʏRpCʔ
@IF NOT EXIST ".\prime.factor.exe" CALL "%SOLOMON_COMPILE_FAILED_CMD%" "%COMPILE_LOG_FILE%" & GOTO :EOF

@REM ʏRpCx
@TYPE "%COMPILE_LOG_FILE%" | FIND /I " warning " >NUL
@IF /I "1" NEQ "%ERRORLEVEL%" CALL "%SOLOMON_COMPILE_WARNED_CMD%" "%COMPILE_LOG_FILE%"

@REM ZteXgpRpC
@SETLOCAL
@CALL "%CALL_VCVARSALL_CMD%" %VCVARSALL_ARG% >NUL
@SET COMPILE_EXECUTE_CMD=cl ".\prime.factor.cpp" /DAUTO_SELF_TEST_BUILD %CL_ARG% /EHsc /W4 /Feprime.factor.test.exe
@ECHO %COMPILE_EXECUTE_CMD%
@%COMPILE_EXECUTE_CMD%>>"%COMPILE2_LOG_FILE%" 2>&1
@ENDLOCAL

@REM ZteXgpRpCʔ
@IF NOT EXIST ".\prime.factor.test.exe" CALL "%SOLOMON_COMPILE_FAILED_CMD%" "%COMPILE2_LOG_FILE%" & GOTO :EOF

@REM ZteXgpRpCx
@TYPE "%COMPILE2_LOG_FILE%" | FIND /I " warning " >NUL
@IF /I "1" NEQ "%ERRORLEVEL%" CALL "%SOLOMON_COMPILE_WARNED_CMD%" "%COMPILE2_LOG_FILE%"

@REM RpCʂ̃Rs[fBNg̍쐬
@SET RESULT_DIR=%SOLOMON_SNAPSHOT_DIR%\result\%BUILD_NAME%
@IF NOT EXIST "%RESULT_DIR%" CALL "%SOLOMON_LIBCMD_DIR%\mkdir.ex.cmd" "%RESULT_DIR%"

@REM RpCʂRs[
@COPY /Y ".\*.exe" "%RESULT_DIR%" >NUL

@REM RpCƂ̒ʒm
CALL "%SOLOMON_COMPILE_SUCCESS_CMD%"


@REM
@REM eXg
@REM

@REM eXgʏo͐
@SET TEST_RESULT_FILE=.\test.result.html
@SET TEST_FAIL_LOG_FILE=.\test.fail.log

@REM eXgs
@SET TEST_EXECUTE_CMD=".\prime.factor.test.exe"^^^>"%TEST_RESULT_FILE%"
@ECHO %TEST_EXECUTE_CMD%
@SET TEST_EXECUTE_CMD=%TEST_EXECUTE_CMD%
@%TEST_EXECUTE_CMD% 2>>"%TEST_FAIL_LOG_FILE%"

@REM eXgۂ̕ۑ
@SET TEST_RESULT=%ERRORLEVEL%

@REM eXgʂRs[
@COPY /Y "%TEST_RESULT_FILE%" "%RESULT_DIR%" >NUL

@REM eXgʔ
@IF "0" EQU "%TEST_RESULT%" (CALL "%SOLOMON_TEST_SUCCESS_CMD%") ELSE CALL "%SOLOMON_TEST_FAILED_CMD%" "%TEST_FAIL_LOG_FILE%" & GOTO :EOF
